function [autocorr batch_mean] = autocorrelation_time(y)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% fonction qui calcule l'autocorrelation temporelle selon la mthode
%%%%% des batch means.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dim = size(y);
if(dim(1,2)>dim(1,1))
    N = dim(1,2);
    dimension = dim(1,1);
    y = y';
else
    N = dim(1,1);
    dimension = dim(1,2);
end
nb_batch = floor(N^(1/3));
size_batch = floor(N^(2/3));

batch_mean = zeros(dimension,nb_batch);
ind_batch = 1;

for i=1:N
   if(i>ind_batch*size_batch)
       ind_batch = ind_batch +1;
   end
   if(ind_batch<=nb_batch)
       batch_mean(:,ind_batch) = batch_mean(:,ind_batch) + y(i,:)';
   end

end

batch_mean = batch_mean/size_batch;

% batch_var = zeros(dimension,nb_batch);
% ind_batch = 1;
% for i=1:N
%    if(i>ind_batch*size_batch)
%        ind_batch = ind_batch +1;
%    end
%    if(ind_batch<=nb_batch)
%        batch_var(:,ind_batch) = batch_var(:,ind_batch) + (batch_mean(:,ind_batch)-y(i,:)').*(batch_mean(:,ind_batch)-y(i,:)');
%    end
% 
% end
% batch_var = batch_var/size_batch;

autocorr = zeros(dimension,1);
batch_var_mean = nb_batch/(nb_batch-1)*var(batch_mean');


% batch_var
% var(batch_var')

for i=1:dimension
%      for q=1:nb_batch-1
%          autocorr(i) = autocorr(i) + size_batch*batch_var(i,q)/var(y(:,i));
%      end
%      autocorr(i) = autocorr(i)/(nb_batch-1);
    autocorr(i) = size_batch*batch_var_mean(i)/var(y(:,i));
end
